#include "usuals.h"  /* typedefs for byte, word16, boolean, etc. */
#define UINT32 word32

typedef struct {
   UINT32 state [16], length0, length1, curlen;
   unsigned char buf [128];
   } sha_state512;
typedef sha_state512 sha_state384;

void sha_init384(sha_state384 *md);
void sha_init512(sha_state512 *md);
void sha_process384(sha_state384 *md, unsigned char *buf, int len);
void sha_process512(sha_state512 *md, unsigned char *buf, int len);
void sha_done384(sha_state384 *md, unsigned char *hash);
void sha_done512(sha_state512 *md, unsigned char *hash);
void sha_memory384(unsigned char *buf, int len, unsigned char *hash);
void sha_memory512(unsigned char *buf, int len, unsigned char *hash);
int sha_file384(unsigned char *filename, unsigned char *hash);
int sha_file512(unsigned char *filename, unsigned char *hash);
